// A listening (server) socket.

#include "lstnsock.h"

CListenSocket::CListenSocket(void)
{

}

CListenSocket::~CListenSocket(void)
{
    if(status)
        CloseSocket();
}


int CListenSocket::CreateSocket(HWND hWnd, UINT message, int port)
{
    if(status)
        return 0;

    sock = socket(AF_INET, SOCK_STREAM, 0);
    if(!sock)
        return 0;
    addr.sin_family = AF_INET;
    #pragma warn -sig   // Don't warn about significant digits
    addr.sin_port = htons(port);
    #pragma warn .sig
    addr.sin_addr.s_addr = htonl(INADDR_ANY); // Accepts connections from "Any Address"

    if(!BindSocket())
        return 0;
    if(!MakeListenSocket(hWnd, message))
        return 0;
    status = 1;

    return 1;
}


int CListenSocket::MakeListenSocket(HWND hWnd, UINT message)
{
    if(listen(sock, CSOCK_BACKLOG) == SOCKET_ERROR)
        return 0;
    if(WSAAsyncSelect(sock, hWnd, message, (FD_ACCEPT | FD_READ | FD_CLOSE)) == SOCKET_ERROR)
        return 0;
    return 1;
}


void CListenSocket::GetText(char* dest, int length)
{
    int bytes = recv(sock, dest, length - 1, 0);
    if(bytes == SOCKET_ERROR)
    {
        dest[0] = '\0';
        return;
    }
    dest[bytes] = '\0';
}

