// A normal socket

#include "normsock.h"

CNormalSocket::CNormalSocket(void)
{

}

CNormalSocket::~CNormalSocket(void)
{
    if(status)
        CloseSocket();
}

int CNormalSocket::CreateSocket(CListenSocket* serversock)
{
	if(status) // Don't create a socket if one already exists
        return 0;

	int addrsize = sizeof(SOCKADDR);
    // Take the connection from the listening socket, "serversock"
	sock = accept(serversock->GetSocket(), &asyncaddr, &addrsize);
	if(sock == INVALID_SOCKET)
	    return 0;
	status = 1;

	return 1;
}

int CNormalSocket::CreateSocket(char* ip, int port, HWND hWnd, UINT message)
{
    if(status)
        return 0;

    sock = socket(AF_INET, SOCK_STREAM, 0);
    if(!sock)
        return 0;

    // Setup the addr structure with the address information of what we are connecting to
    addr.sin_family = AF_INET;
    #pragma warn -sig   // Don't warn about significant digits
    addr.sin_port = htons(port);
    #pragma warn .sig 
    addr.sin_addr.s_addr = inet_addr(ip);

    // Connect the socket
    if(connect(sock, (LPSOCKADDR)&addr, sizeof(addr)) == SOCKET_ERROR)
        return 0;

    // Setup the socket to send windows messages when network events occure
    if(hWnd)
        if(WSAAsyncSelect(sock, hWnd, message, (FD_READ | FD_CLOSE)) == SOCKET_ERROR)
            return 0;

    status = 1;
    return 1;
}

void CNormalSocket::GetText(char* dest, int length)
{
    int bytes = recv(sock, dest, length - 1, 0);
    if(bytes == SOCKET_ERROR)
    {
        dest[0] = '\0';
        return;
    }
    dest[bytes] = '\0';
}
